#region Copyright Syncfusion Inc. 2001 - 2006
//
//  Copyright Syncfusion Inc. 2001 - 2006. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Collections;
using System.ComponentModel;

using Syncfusion.Windows.Forms.Diagram;

namespace Hierarchical_tree_diagram_DirectedTreeLayout_Manager
{
	/// <summary>
	/// The DiagramLayoutManager class is an implementor of the Essential Diagram LayoutManager functionality.
	/// This is a very simple layout management algorithm that calculates the sub-employees associated with 
	/// each employee and allocates space accordingly. More efficient management strategies may be used for 
	/// better diagram layout.
	/// </summary>
	public class DiagramLayoutManager : LayoutManager
	{
		public DiagramLayoutManager()
		{
		}

		public DiagramLayoutManager(Model mdl) : base(mdl)
		{
		}

		public override bool UpdateLayout(object contextInfo)
		{
			bool changesMade = true;

			if(this.Model != null)
			{
				ArrayList topRanking = new ArrayList();

				foreach (INode curNode in this.Model.Nodes)
				{
					MyTextSymbol expsymbol = curNode as MyTextSymbol;
							topRanking.Add(expsymbol);
				}
					float curLeft = this.Model.Bounds.Left;
					float curRight = curLeft;
				foreach(MyTextSymbol curMember in topRanking)
					{
						this.PositionMember(curMember);
						curLeft = curRight;						
					}
			}

			if(changesMade)
			{
				this.OnLayoutUpdated(new System.EventArgs());
			}

			return changesMade;
		}

		private void PositionMember(MyTextSymbol expsymbol)
		{
			if(expsymbol!=null)
			{
				if(expsymbol.Name=="NodeA")
				{
				expsymbol.X=280;
				expsymbol.Y=250;
				}
				if(expsymbol.Name=="NodeB")
				{
					expsymbol.X=150;
					expsymbol.Y=350;
				}
				if(expsymbol.Name=="NodeC")
				{
					expsymbol.X=430;
					expsymbol.Y=350;
				}
				if(expsymbol.Name=="NodeD")
				{
					expsymbol.X=150;
					expsymbol.Y=150;
				} 
				if(expsymbol.Name=="NodeE")
				{
					expsymbol.X=430;
					expsymbol.Y=150;
				}
				if(expsymbol.Name=="NodeB1")
				{
					expsymbol.X=70;
					expsymbol.Y=420;
				}
				if(expsymbol.Name=="NodeB2")
				{
					expsymbol.X=230;
					expsymbol.Y=420;
				}
				if(expsymbol.Name=="NodeB11")
				{
					expsymbol.X=70;
					expsymbol.Y=500;
				}
				if(expsymbol.Name=="NodeB21")
				{
					expsymbol.X=230;
					expsymbol.Y=500;
				}
				if(expsymbol.Name=="NodeC1")
				{
					expsymbol.X=70;
					expsymbol.Y=80;
				}
				if(expsymbol.Name=="NodeC2")
				{
					expsymbol.X=230;
					expsymbol.Y=80;
				}
				if(expsymbol.Name=="NodeC11")
				{
					expsymbol.X=70;
					expsymbol.Y=10;
				}

				if(expsymbol.Name=="NodeC21")
				{
					expsymbol.X=230;
					expsymbol.Y=10;
				}
			}
		}	
	}
}
