using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Diagram;

namespace Hierarchical_tree_diagram_DirectedTreeLayout_Manager
{
	
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Diagram.Controls.Diagram diagram1;
		private DiagramLayoutManager diagramlayoutMgr;
		
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			InitializeComponent();
			this.diagramlayoutMgr = new DiagramLayoutManager();
			this.diagram1.LayoutManager = this.diagramlayoutMgr;
			this.diagram1.Model.RenderingStyle.SmoothingMode=System.Drawing.Drawing2D.SmoothingMode.AntiAlias;
			InitializeDiagramWithLayoutManager();
		}

		// Add the child symbols to the diagram and connect the symbols to form the diagram graph. 
		// This method uses the DirectedTreeLayoutManager to lay out the nodes as a vertical tree graph.
		protected void InitializeDiagramWithLayoutManager()
		{
			#region Add Symbols

			Syncfusion.Windows.Forms.Diagram.InsertNodesCmd cmd = new Syncfusion.Windows.Forms.Diagram.InsertNodesCmd();
			MyTextSymbol mysymbolA = new MyTextSymbol("node A");
			mysymbolA.Name="NodeA";
			cmd.Nodes.Add(mysymbolA);
			diagram1.Controller.ExecuteCommand(cmd);			

			MyTextSymbol mysymbolB = new MyTextSymbol("node B");
			cmd.Nodes.Clear();
			mysymbolB.Name="NodeB";
			cmd.Nodes.Add(mysymbolB);
			diagram1.Controller.ExecuteCommand(cmd);

			MyTextSymbol mysymbolB1 = new MyTextSymbol("node B1");
			cmd.Nodes.Clear();
			mysymbolB1.Name="NodeB1";
			cmd.Nodes.Add(mysymbolB1);
			diagram1.Controller.ExecuteCommand(cmd);
			
			MyTextSymbol mysymbolB11 = new MyTextSymbol("node B11");
			cmd.Nodes.Clear();
			mysymbolB11.Name="NodeB11";
			cmd.Nodes.Add(mysymbolB11);
			diagram1.Controller.ExecuteCommand(cmd);

			MyTextSymbol mysymbolB2 = new MyTextSymbol("node B2");
			cmd.Nodes.Clear();
			mysymbolB2.Name="NodeB2";
			cmd.Nodes.Add(mysymbolB2);
			diagram1.Controller.ExecuteCommand(cmd);

			MyTextSymbol mysymbolB21 = new MyTextSymbol("node B21");			
			cmd.Nodes.Clear();
			mysymbolB21.Name="NodeB21";
			cmd.Nodes.Add(mysymbolB21);
			diagram1.Controller.ExecuteCommand(cmd);

			MyTextSymbol mysymbolD = new MyTextSymbol("node D");
			cmd.Nodes.Clear();
			mysymbolD.Name="NodeD";
			cmd.AddNode(mysymbolD,new PointF(200,150));
			diagram1.Controller.ExecuteCommand(cmd);
			
			MyTextSymbol mysymbolE = new MyTextSymbol("node E");
			cmd.Nodes.Clear();
			mysymbolE.Name="NodeE";
			cmd.Nodes.Add(mysymbolE);
			diagram1.Controller.ExecuteCommand(cmd);

			MyTextSymbol mysymbolC = new MyTextSymbol("node C");
			cmd.Nodes.Clear();
			mysymbolC.Name="NodeC";
			cmd.Nodes.Add(mysymbolC);
			diagram1.Controller.ExecuteCommand(cmd);

			MyTextSymbol mysymbolC1 = new MyTextSymbol("node C1");
			cmd.Nodes.Clear();
			mysymbolC1.Name="NodeC1";
			cmd.Nodes.Add(mysymbolC1);
			diagram1.Controller.ExecuteCommand(cmd);

			MyTextSymbol mysymbolC11 = new MyTextSymbol("node C11");
			cmd.Nodes.Clear();
			mysymbolC11.Name="NodeC11";
			cmd.Nodes.Add(mysymbolC11);
			diagram1.Controller.ExecuteCommand(cmd);

			MyTextSymbol mysymbolC2 = new MyTextSymbol("node C2");
			cmd.Nodes.Clear();
			mysymbolC2.Name="NodeC2";
			cmd.Nodes.Add(mysymbolC2);
			diagram1.Controller.ExecuteCommand(cmd);

			MyTextSymbol mysymbolC21 = new MyTextSymbol("node C21");
			cmd.Nodes.Clear();
			mysymbolC21.Name="NodeC21";
			cmd.Nodes.Add(mysymbolC21);
			diagram1.Controller.ExecuteCommand(cmd);

			#endregion

			#region //Add Links

			LinkCmd lnkcmd = new LinkCmd();
			lnkcmd.Link = new Link(Syncfusion.Windows.Forms.Diagram.Link.Shapes.Polyline);
			lnkcmd.Link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
			lnkcmd.Link.EndPoints.LastEndPointDecorator.FillStyle.Color = Color.Black;
			lnkcmd.SourcePort = mysymbolA.topport;
			lnkcmd.TargetPort = mysymbolD.bottomport;			
			diagram1.Controller.ExecuteCommand(lnkcmd);

			lnkcmd.Link = new Link(Syncfusion.Windows.Forms.Diagram.Link.Shapes.Polyline);
			lnkcmd.Link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
			lnkcmd.Link.EndPoints.LastEndPointDecorator.FillStyle.Color = Color.Black;
			lnkcmd.SourcePort =mysymbolA.topport;
			lnkcmd.TargetPort = mysymbolE.bottomport;	
			diagram1.Controller.ExecuteCommand(lnkcmd);

			
			lnkcmd.Link = new Link(Syncfusion.Windows.Forms.Diagram.Link.Shapes.Polyline);
			lnkcmd.Link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
			lnkcmd.Link.EndPoints.LastEndPointDecorator.FillStyle.Color = Color.Black;
			lnkcmd.SourcePort = mysymbolA.bottomport;
			lnkcmd.TargetPort = mysymbolB.topport;			
			diagram1.Controller.ExecuteCommand(lnkcmd);

			lnkcmd.Link = new Link(Syncfusion.Windows.Forms.Diagram.Link.Shapes.Polyline);
			lnkcmd.Link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
			lnkcmd.Link.EndPoints.LastEndPointDecorator.FillStyle.Color = Color.Black;
			lnkcmd.SourcePort = mysymbolA.bottomport;
			lnkcmd.TargetPort = mysymbolC.topport;
			diagram1.Controller.ExecuteCommand(lnkcmd);

			

			lnkcmd.Link = new Link(Syncfusion.Windows.Forms.Diagram.Link.Shapes.Polyline);
			lnkcmd.Link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
			lnkcmd.Link.EndPoints.LastEndPointDecorator.FillStyle.Color = Color.Black;
			lnkcmd.SourcePort = mysymbolB.CenterPort;
			lnkcmd.TargetPort = mysymbolB1.CenterPort;
			diagram1.Controller.ExecuteCommand(lnkcmd);

			lnkcmd.Link = new Link(Syncfusion.Windows.Forms.Diagram.Link.Shapes.Polyline);
			lnkcmd.Link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
			lnkcmd.Link.EndPoints.LastEndPointDecorator.FillStyle.Color = Color.Black;
			lnkcmd.SourcePort = mysymbolB.CenterPort;
			lnkcmd.TargetPort = mysymbolB2.CenterPort;
			diagram1.Controller.ExecuteCommand(lnkcmd);

			lnkcmd.Link = new Link(Syncfusion.Windows.Forms.Diagram.Link.Shapes.Polyline);
			lnkcmd.Link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
			lnkcmd.Link.EndPoints.LastEndPointDecorator.FillStyle.Color = Color.Black;
			lnkcmd.SourcePort = mysymbolB1.CenterPort;
			lnkcmd.TargetPort = mysymbolB11.CenterPort;
			diagram1.Controller.ExecuteCommand(lnkcmd);

			lnkcmd.Link = new Link(Syncfusion.Windows.Forms.Diagram.Link.Shapes.Polyline);
			lnkcmd.Link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
			lnkcmd.Link.EndPoints.LastEndPointDecorator.FillStyle.Color = Color.Black;
			lnkcmd.SourcePort = mysymbolB2.CenterPort;
			lnkcmd.TargetPort = mysymbolB21.CenterPort;
			diagram1.Controller.ExecuteCommand(lnkcmd);
			lnkcmd.Link = new Link(Syncfusion.Windows.Forms.Diagram.Link.Shapes.Line);
			lnkcmd.Link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
			lnkcmd.Link.EndPoints.LastEndPointDecorator.FillStyle.Color = Color.Black;
			lnkcmd.SourcePort = mysymbolD.CenterPort;
			lnkcmd.TargetPort = mysymbolC1.CenterPort;
			diagram1.Controller.ExecuteCommand(lnkcmd);

			lnkcmd.Link = new Link(Syncfusion.Windows.Forms.Diagram.Link.Shapes.Line);
			lnkcmd.Link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
			lnkcmd.Link.EndPoints.LastEndPointDecorator.FillStyle.Color = Color.Black;
			lnkcmd.SourcePort = mysymbolC1.CenterPort;
			lnkcmd.TargetPort = mysymbolC11.CenterPort;
			diagram1.Controller.ExecuteCommand(lnkcmd);

			lnkcmd.Link = new Link(Syncfusion.Windows.Forms.Diagram.Link.Shapes.Line);
			lnkcmd.Link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
			lnkcmd.Link.EndPoints.LastEndPointDecorator.FillStyle.Color = Color.Black;
			lnkcmd.SourcePort = mysymbolD.CenterPort;
			lnkcmd.TargetPort = mysymbolC2.CenterPort;
			diagram1.Controller.ExecuteCommand(lnkcmd);

			lnkcmd.Link = new Link(Syncfusion.Windows.Forms.Diagram.Link.Shapes.Line);
			lnkcmd.Link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
			lnkcmd.Link.EndPoints.LastEndPointDecorator.FillStyle.Color = Color.Black;
			lnkcmd.SourcePort = mysymbolC2.CenterPort;
			lnkcmd.TargetPort = mysymbolC21.CenterPort;
			diagram1.Controller.ExecuteCommand(lnkcmd);
			this.diagramlayoutMgr.UpdateLayout(null);

			#endregion
		}
		
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.diagram1 = new Syncfusion.Windows.Forms.Diagram.Controls.Diagram();
			((System.ComponentModel.ISupportInitialize)(this.diagram1.Model)).BeginInit();
			this.SuspendLayout();
			// 
			// diagram1
			// 
			this.diagram1.AllowDrop = true;
			// 
			// diagram1.Controller
			// 
			this.diagram1.Controller.MaxHistory = 256;
			this.diagram1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.diagram1.HScroll = true;
			this.diagram1.LayoutManager = null;
			this.diagram1.Location = new System.Drawing.Point(0, 0);
			// 
			// diagram1.Model
			// 
			this.diagram1.Model.Height = 1056F;
			this.diagram1.Model.Name = "Model";
			this.diagram1.Model.Width = 816F;
			this.diagram1.Name = "diagram1";
			this.diagram1.Size = new System.Drawing.Size(712, 478);
			this.diagram1.SmartSizeBox = false;
			this.diagram1.TabIndex = 0;
			this.diagram1.Text = "diagram1";
			// 
			// diagram1.View
			// 
			this.diagram1.View.Grid.Visible = false;
			this.diagram1.VScroll = true;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(712, 478);
			this.Controls.Add(this.diagram1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.diagram1.Model)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			// Add a TextNode to highlight the subnode feature

			Syncfusion.Windows.Forms.Diagram.InsertNodesCmd cmd = new Syncfusion.Windows.Forms.Diagram.InsertNodesCmd();
			Syncfusion.Windows.Forms.Diagram.TextNode txtnode = new TextNode();
			txtnode.Text = "Hierarchical Tree Diagram";
			txtnode.FontStyle.Size = 18;
			txtnode.FontStyle.Bold = true;
			txtnode.FontStyle.Family = "Arial";
			txtnode.FillStyle.Color = Color.Black;
			txtnode.Bounds = new RectangleF(400,50,320,30);
			cmd.Nodes.Add(txtnode);
			diagram1.Controller.ExecuteCommand(cmd);
		}
	}
}
