using System;
using System.Drawing;
using System.Runtime.Serialization;
using Syncfusion.Windows.Forms.Diagram;

namespace Hierarchical_tree_diagram_DirectedTreeLayout_Manager
{
	/// <summary>
	/// Summary description for MyTextSymbol.
	/// </summary>
	[Serializable()]
	public class MyTextSymbol : Symbol
	{
		public CirclePort leftport;
		public CirclePort rightport;
		public CirclePort topport;
		public CirclePort bottomport;

		public AnchoredPort TopPort; 
		public AnchoredPort BottomPort; 

		public MyTextSymbol()
		{
			
			Syncfusion.Windows.Forms.Diagram.TextNode node = new Syncfusion.Windows.Forms.Diagram.TextNode();
			node.Width = 300;
			node.Height = 100;
			node.Text = "node";
			node.BorderStyle.BorderWidth = 2;
			node.BorderStyle.BorderColor = Color.Green;
			node.BorderStyle.ShowBorder = true;
			node.SizeToText(new SizeF(1000,1000));
			this.Nodes.Add(node);
		}

		public MyTextSymbol(string text)
		{
			
			Syncfusion.Windows.Forms.Diagram.TextNode node = new Syncfusion.Windows.Forms.Diagram.TextNode();
			node.Width = 300;
			node.Height = 100;
			node.Text = text;
			node.BorderStyle.BorderWidth = 2;
			node.BorderStyle.BorderColor = Color.Green;
			node.BorderStyle.ShowBorder = true;
			node.SizeToText(new SizeF(1000,1000));
			this.Nodes.Add(node);

			this.TopPort= new AnchoredPort(this, BoxPosition.TopCenter);
			this.BottomPort= new AnchoredPort(this, BoxPosition.BottomCenter);
			topport = new CirclePort(new PointF(this.Width / 2, 0));
			bottomport = new CirclePort(new PointF(this.Width / 2, this.Height));
			topport.Visible = false;
			bottomport.Visible = false;

			AppendChild(topport);
			AppendChild(bottomport);
		}

		/// <summary>
		/// Serialization constructor for symbols.
		/// </summary>
		/// <param name="info">Serialization state information</param>
		/// <param name="context">Streaming context information</param>
		protected MyTextSymbol(SerializationInfo info, StreamingContext context) : base(info, context)
		{
		}		

		/// <summary>
		/// Populates a SerializationInfo with the data needed to
		/// serialize the target object.
		/// </summary>
		/// <param name="info">SerializationInfo object to populate</param>
		/// <param name="context">Destination streaming context</param>
		protected override void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			base.GetObjectData(info, context);
		}

		/// <summary>
		/// Called when deserialization is complete.
		/// </summary>
		/// <param name="sender">Object performing the deserialization</param>
		protected override void OnDeserialization(object sender)
		{
			base.OnDeserialization(sender);
		}
	}
}
